//go:build !ignore_autogenerated
// +build !ignore_autogenerated

/*
Copyright The Kubernetes Authors.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by conversion-gen. DO NOT EDIT.

package v1beta1

import (
	unsafe "unsafe"

	corev1 "k8s.io/api/core/v1"
	resourcev1beta1 "k8s.io/api/resource/v1beta1"
	v1beta2 "k8s.io/api/resource/v1beta2"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	conversion "k8s.io/apimachinery/pkg/conversion"
	runtime "k8s.io/apimachinery/pkg/runtime"
	types "k8s.io/apimachinery/pkg/types"
)

func init() {
	localSchemeBuilder.Register(RegisterConversions)
}

// RegisterConversions adds conversion functions to the given scheme.
// Public to allow building arbitrary schemes.
func RegisterConversions(s *runtime.Scheme) error {
	if err := s.AddGeneratedConversionFunc((*v1beta2.AllocatedDeviceStatus)(nil), (*resourcev1beta1.AllocatedDeviceStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_AllocatedDeviceStatus_To_v1beta1_AllocatedDeviceStatus(a.(*v1beta2.AllocatedDeviceStatus), b.(*resourcev1beta1.AllocatedDeviceStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.AllocatedDeviceStatus)(nil), (*v1beta2.AllocatedDeviceStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_AllocatedDeviceStatus_To_v1beta2_AllocatedDeviceStatus(a.(*resourcev1beta1.AllocatedDeviceStatus), b.(*v1beta2.AllocatedDeviceStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.AllocationResult)(nil), (*resourcev1beta1.AllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_AllocationResult_To_v1beta1_AllocationResult(a.(*v1beta2.AllocationResult), b.(*resourcev1beta1.AllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.AllocationResult)(nil), (*v1beta2.AllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_AllocationResult_To_v1beta2_AllocationResult(a.(*resourcev1beta1.AllocationResult), b.(*v1beta2.AllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.CELDeviceSelector)(nil), (*resourcev1beta1.CELDeviceSelector)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_CELDeviceSelector_To_v1beta1_CELDeviceSelector(a.(*v1beta2.CELDeviceSelector), b.(*resourcev1beta1.CELDeviceSelector), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.CELDeviceSelector)(nil), (*v1beta2.CELDeviceSelector)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_CELDeviceSelector_To_v1beta2_CELDeviceSelector(a.(*resourcev1beta1.CELDeviceSelector), b.(*v1beta2.CELDeviceSelector), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.Counter)(nil), (*resourcev1beta1.Counter)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_Counter_To_v1beta1_Counter(a.(*v1beta2.Counter), b.(*resourcev1beta1.Counter), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.Counter)(nil), (*v1beta2.Counter)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_Counter_To_v1beta2_Counter(a.(*resourcev1beta1.Counter), b.(*v1beta2.Counter), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.CounterSet)(nil), (*resourcev1beta1.CounterSet)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_CounterSet_To_v1beta1_CounterSet(a.(*v1beta2.CounterSet), b.(*resourcev1beta1.CounterSet), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.CounterSet)(nil), (*v1beta2.CounterSet)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_CounterSet_To_v1beta2_CounterSet(a.(*resourcev1beta1.CounterSet), b.(*v1beta2.CounterSet), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceAllocationConfiguration)(nil), (*resourcev1beta1.DeviceAllocationConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceAllocationConfiguration_To_v1beta1_DeviceAllocationConfiguration(a.(*v1beta2.DeviceAllocationConfiguration), b.(*resourcev1beta1.DeviceAllocationConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceAllocationConfiguration)(nil), (*v1beta2.DeviceAllocationConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceAllocationConfiguration_To_v1beta2_DeviceAllocationConfiguration(a.(*resourcev1beta1.DeviceAllocationConfiguration), b.(*v1beta2.DeviceAllocationConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceAllocationResult)(nil), (*resourcev1beta1.DeviceAllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceAllocationResult_To_v1beta1_DeviceAllocationResult(a.(*v1beta2.DeviceAllocationResult), b.(*resourcev1beta1.DeviceAllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceAllocationResult)(nil), (*v1beta2.DeviceAllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult(a.(*resourcev1beta1.DeviceAllocationResult), b.(*v1beta2.DeviceAllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceAttribute)(nil), (*resourcev1beta1.DeviceAttribute)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceAttribute_To_v1beta1_DeviceAttribute(a.(*v1beta2.DeviceAttribute), b.(*resourcev1beta1.DeviceAttribute), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceAttribute)(nil), (*v1beta2.DeviceAttribute)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceAttribute_To_v1beta2_DeviceAttribute(a.(*resourcev1beta1.DeviceAttribute), b.(*v1beta2.DeviceAttribute), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceCapacity)(nil), (*resourcev1beta1.DeviceCapacity)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceCapacity_To_v1beta1_DeviceCapacity(a.(*v1beta2.DeviceCapacity), b.(*resourcev1beta1.DeviceCapacity), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceCapacity)(nil), (*v1beta2.DeviceCapacity)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceCapacity_To_v1beta2_DeviceCapacity(a.(*resourcev1beta1.DeviceCapacity), b.(*v1beta2.DeviceCapacity), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceClaim)(nil), (*resourcev1beta1.DeviceClaim)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClaim_To_v1beta1_DeviceClaim(a.(*v1beta2.DeviceClaim), b.(*resourcev1beta1.DeviceClaim), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceClaim)(nil), (*v1beta2.DeviceClaim)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceClaim_To_v1beta2_DeviceClaim(a.(*resourcev1beta1.DeviceClaim), b.(*v1beta2.DeviceClaim), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceClaimConfiguration)(nil), (*resourcev1beta1.DeviceClaimConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClaimConfiguration_To_v1beta1_DeviceClaimConfiguration(a.(*v1beta2.DeviceClaimConfiguration), b.(*resourcev1beta1.DeviceClaimConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceClaimConfiguration)(nil), (*v1beta2.DeviceClaimConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceClaimConfiguration_To_v1beta2_DeviceClaimConfiguration(a.(*resourcev1beta1.DeviceClaimConfiguration), b.(*v1beta2.DeviceClaimConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceClass)(nil), (*resourcev1beta1.DeviceClass)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClass_To_v1beta1_DeviceClass(a.(*v1beta2.DeviceClass), b.(*resourcev1beta1.DeviceClass), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceClass)(nil), (*v1beta2.DeviceClass)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceClass_To_v1beta2_DeviceClass(a.(*resourcev1beta1.DeviceClass), b.(*v1beta2.DeviceClass), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceClassConfiguration)(nil), (*resourcev1beta1.DeviceClassConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClassConfiguration_To_v1beta1_DeviceClassConfiguration(a.(*v1beta2.DeviceClassConfiguration), b.(*resourcev1beta1.DeviceClassConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceClassConfiguration)(nil), (*v1beta2.DeviceClassConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceClassConfiguration_To_v1beta2_DeviceClassConfiguration(a.(*resourcev1beta1.DeviceClassConfiguration), b.(*v1beta2.DeviceClassConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceClassList)(nil), (*resourcev1beta1.DeviceClassList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClassList_To_v1beta1_DeviceClassList(a.(*v1beta2.DeviceClassList), b.(*resourcev1beta1.DeviceClassList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceClassList)(nil), (*v1beta2.DeviceClassList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceClassList_To_v1beta2_DeviceClassList(a.(*resourcev1beta1.DeviceClassList), b.(*v1beta2.DeviceClassList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceClassSpec)(nil), (*resourcev1beta1.DeviceClassSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceClassSpec_To_v1beta1_DeviceClassSpec(a.(*v1beta2.DeviceClassSpec), b.(*resourcev1beta1.DeviceClassSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceClassSpec)(nil), (*v1beta2.DeviceClassSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceClassSpec_To_v1beta2_DeviceClassSpec(a.(*resourcev1beta1.DeviceClassSpec), b.(*v1beta2.DeviceClassSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceConfiguration)(nil), (*resourcev1beta1.DeviceConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceConfiguration_To_v1beta1_DeviceConfiguration(a.(*v1beta2.DeviceConfiguration), b.(*resourcev1beta1.DeviceConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceConfiguration)(nil), (*v1beta2.DeviceConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceConfiguration_To_v1beta2_DeviceConfiguration(a.(*resourcev1beta1.DeviceConfiguration), b.(*v1beta2.DeviceConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceConstraint)(nil), (*resourcev1beta1.DeviceConstraint)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceConstraint_To_v1beta1_DeviceConstraint(a.(*v1beta2.DeviceConstraint), b.(*resourcev1beta1.DeviceConstraint), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceConstraint)(nil), (*v1beta2.DeviceConstraint)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceConstraint_To_v1beta2_DeviceConstraint(a.(*resourcev1beta1.DeviceConstraint), b.(*v1beta2.DeviceConstraint), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceCounterConsumption)(nil), (*resourcev1beta1.DeviceCounterConsumption)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceCounterConsumption_To_v1beta1_DeviceCounterConsumption(a.(*v1beta2.DeviceCounterConsumption), b.(*resourcev1beta1.DeviceCounterConsumption), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceCounterConsumption)(nil), (*v1beta2.DeviceCounterConsumption)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceCounterConsumption_To_v1beta2_DeviceCounterConsumption(a.(*resourcev1beta1.DeviceCounterConsumption), b.(*v1beta2.DeviceCounterConsumption), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceRequestAllocationResult)(nil), (*resourcev1beta1.DeviceRequestAllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceRequestAllocationResult_To_v1beta1_DeviceRequestAllocationResult(a.(*v1beta2.DeviceRequestAllocationResult), b.(*resourcev1beta1.DeviceRequestAllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceRequestAllocationResult)(nil), (*v1beta2.DeviceRequestAllocationResult)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceRequestAllocationResult_To_v1beta2_DeviceRequestAllocationResult(a.(*resourcev1beta1.DeviceRequestAllocationResult), b.(*v1beta2.DeviceRequestAllocationResult), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceSelector)(nil), (*resourcev1beta1.DeviceSelector)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceSelector_To_v1beta1_DeviceSelector(a.(*v1beta2.DeviceSelector), b.(*resourcev1beta1.DeviceSelector), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceSelector)(nil), (*v1beta2.DeviceSelector)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceSelector_To_v1beta2_DeviceSelector(a.(*resourcev1beta1.DeviceSelector), b.(*v1beta2.DeviceSelector), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceSubRequest)(nil), (*resourcev1beta1.DeviceSubRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceSubRequest_To_v1beta1_DeviceSubRequest(a.(*v1beta2.DeviceSubRequest), b.(*resourcev1beta1.DeviceSubRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceSubRequest)(nil), (*v1beta2.DeviceSubRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceSubRequest_To_v1beta2_DeviceSubRequest(a.(*resourcev1beta1.DeviceSubRequest), b.(*v1beta2.DeviceSubRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceTaint)(nil), (*resourcev1beta1.DeviceTaint)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceTaint_To_v1beta1_DeviceTaint(a.(*v1beta2.DeviceTaint), b.(*resourcev1beta1.DeviceTaint), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceTaint)(nil), (*v1beta2.DeviceTaint)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceTaint_To_v1beta2_DeviceTaint(a.(*resourcev1beta1.DeviceTaint), b.(*v1beta2.DeviceTaint), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.DeviceToleration)(nil), (*resourcev1beta1.DeviceToleration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceToleration_To_v1beta1_DeviceToleration(a.(*v1beta2.DeviceToleration), b.(*resourcev1beta1.DeviceToleration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.DeviceToleration)(nil), (*v1beta2.DeviceToleration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceToleration_To_v1beta2_DeviceToleration(a.(*resourcev1beta1.DeviceToleration), b.(*v1beta2.DeviceToleration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.NetworkDeviceData)(nil), (*resourcev1beta1.NetworkDeviceData)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_NetworkDeviceData_To_v1beta1_NetworkDeviceData(a.(*v1beta2.NetworkDeviceData), b.(*resourcev1beta1.NetworkDeviceData), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.NetworkDeviceData)(nil), (*v1beta2.NetworkDeviceData)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_NetworkDeviceData_To_v1beta2_NetworkDeviceData(a.(*resourcev1beta1.NetworkDeviceData), b.(*v1beta2.NetworkDeviceData), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.OpaqueDeviceConfiguration)(nil), (*resourcev1beta1.OpaqueDeviceConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_OpaqueDeviceConfiguration_To_v1beta1_OpaqueDeviceConfiguration(a.(*v1beta2.OpaqueDeviceConfiguration), b.(*resourcev1beta1.OpaqueDeviceConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.OpaqueDeviceConfiguration)(nil), (*v1beta2.OpaqueDeviceConfiguration)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_OpaqueDeviceConfiguration_To_v1beta2_OpaqueDeviceConfiguration(a.(*resourcev1beta1.OpaqueDeviceConfiguration), b.(*v1beta2.OpaqueDeviceConfiguration), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.ResourceClaim)(nil), (*resourcev1beta1.ResourceClaim)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaim_To_v1beta1_ResourceClaim(a.(*v1beta2.ResourceClaim), b.(*resourcev1beta1.ResourceClaim), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.ResourceClaim)(nil), (*v1beta2.ResourceClaim)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourceClaim_To_v1beta2_ResourceClaim(a.(*resourcev1beta1.ResourceClaim), b.(*v1beta2.ResourceClaim), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.ResourceClaimConsumerReference)(nil), (*resourcev1beta1.ResourceClaimConsumerReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimConsumerReference_To_v1beta1_ResourceClaimConsumerReference(a.(*v1beta2.ResourceClaimConsumerReference), b.(*resourcev1beta1.ResourceClaimConsumerReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.ResourceClaimConsumerReference)(nil), (*v1beta2.ResourceClaimConsumerReference)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourceClaimConsumerReference_To_v1beta2_ResourceClaimConsumerReference(a.(*resourcev1beta1.ResourceClaimConsumerReference), b.(*v1beta2.ResourceClaimConsumerReference), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.ResourceClaimList)(nil), (*resourcev1beta1.ResourceClaimList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimList_To_v1beta1_ResourceClaimList(a.(*v1beta2.ResourceClaimList), b.(*resourcev1beta1.ResourceClaimList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.ResourceClaimList)(nil), (*v1beta2.ResourceClaimList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourceClaimList_To_v1beta2_ResourceClaimList(a.(*resourcev1beta1.ResourceClaimList), b.(*v1beta2.ResourceClaimList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.ResourceClaimSpec)(nil), (*resourcev1beta1.ResourceClaimSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimSpec_To_v1beta1_ResourceClaimSpec(a.(*v1beta2.ResourceClaimSpec), b.(*resourcev1beta1.ResourceClaimSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.ResourceClaimSpec)(nil), (*v1beta2.ResourceClaimSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(a.(*resourcev1beta1.ResourceClaimSpec), b.(*v1beta2.ResourceClaimSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.ResourceClaimStatus)(nil), (*resourcev1beta1.ResourceClaimStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimStatus_To_v1beta1_ResourceClaimStatus(a.(*v1beta2.ResourceClaimStatus), b.(*resourcev1beta1.ResourceClaimStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.ResourceClaimStatus)(nil), (*v1beta2.ResourceClaimStatus)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus(a.(*resourcev1beta1.ResourceClaimStatus), b.(*v1beta2.ResourceClaimStatus), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.ResourceClaimTemplate)(nil), (*resourcev1beta1.ResourceClaimTemplate)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimTemplate_To_v1beta1_ResourceClaimTemplate(a.(*v1beta2.ResourceClaimTemplate), b.(*resourcev1beta1.ResourceClaimTemplate), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.ResourceClaimTemplate)(nil), (*v1beta2.ResourceClaimTemplate)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourceClaimTemplate_To_v1beta2_ResourceClaimTemplate(a.(*resourcev1beta1.ResourceClaimTemplate), b.(*v1beta2.ResourceClaimTemplate), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.ResourceClaimTemplateList)(nil), (*resourcev1beta1.ResourceClaimTemplateList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimTemplateList_To_v1beta1_ResourceClaimTemplateList(a.(*v1beta2.ResourceClaimTemplateList), b.(*resourcev1beta1.ResourceClaimTemplateList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.ResourceClaimTemplateList)(nil), (*v1beta2.ResourceClaimTemplateList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourceClaimTemplateList_To_v1beta2_ResourceClaimTemplateList(a.(*resourcev1beta1.ResourceClaimTemplateList), b.(*v1beta2.ResourceClaimTemplateList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.ResourceClaimTemplateSpec)(nil), (*resourcev1beta1.ResourceClaimTemplateSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceClaimTemplateSpec_To_v1beta1_ResourceClaimTemplateSpec(a.(*v1beta2.ResourceClaimTemplateSpec), b.(*resourcev1beta1.ResourceClaimTemplateSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.ResourceClaimTemplateSpec)(nil), (*v1beta2.ResourceClaimTemplateSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec(a.(*resourcev1beta1.ResourceClaimTemplateSpec), b.(*v1beta2.ResourceClaimTemplateSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.ResourcePool)(nil), (*resourcev1beta1.ResourcePool)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourcePool_To_v1beta1_ResourcePool(a.(*v1beta2.ResourcePool), b.(*resourcev1beta1.ResourcePool), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.ResourcePool)(nil), (*v1beta2.ResourcePool)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourcePool_To_v1beta2_ResourcePool(a.(*resourcev1beta1.ResourcePool), b.(*v1beta2.ResourcePool), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.ResourceSlice)(nil), (*resourcev1beta1.ResourceSlice)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceSlice_To_v1beta1_ResourceSlice(a.(*v1beta2.ResourceSlice), b.(*resourcev1beta1.ResourceSlice), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.ResourceSlice)(nil), (*v1beta2.ResourceSlice)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourceSlice_To_v1beta2_ResourceSlice(a.(*resourcev1beta1.ResourceSlice), b.(*v1beta2.ResourceSlice), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*v1beta2.ResourceSliceList)(nil), (*resourcev1beta1.ResourceSliceList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceSliceList_To_v1beta1_ResourceSliceList(a.(*v1beta2.ResourceSliceList), b.(*resourcev1beta1.ResourceSliceList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddGeneratedConversionFunc((*resourcev1beta1.ResourceSliceList)(nil), (*v1beta2.ResourceSliceList)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourceSliceList_To_v1beta2_ResourceSliceList(a.(*resourcev1beta1.ResourceSliceList), b.(*v1beta2.ResourceSliceList), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*resourcev1beta1.DeviceRequest)(nil), (*v1beta2.DeviceRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_DeviceRequest_To_v1beta2_DeviceRequest(a.(*resourcev1beta1.DeviceRequest), b.(*v1beta2.DeviceRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*resourcev1beta1.Device)(nil), (*v1beta2.Device)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_Device_To_v1beta2_Device(a.(*resourcev1beta1.Device), b.(*v1beta2.Device), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*resourcev1beta1.ResourceSliceSpec)(nil), (*v1beta2.ResourceSliceSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta1_ResourceSliceSpec_To_v1beta2_ResourceSliceSpec(a.(*resourcev1beta1.ResourceSliceSpec), b.(*v1beta2.ResourceSliceSpec), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1beta2.DeviceRequest)(nil), (*resourcev1beta1.DeviceRequest)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_DeviceRequest_To_v1beta1_DeviceRequest(a.(*v1beta2.DeviceRequest), b.(*resourcev1beta1.DeviceRequest), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1beta2.Device)(nil), (*resourcev1beta1.Device)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_Device_To_v1beta1_Device(a.(*v1beta2.Device), b.(*resourcev1beta1.Device), scope)
	}); err != nil {
		return err
	}
	if err := s.AddConversionFunc((*v1beta2.ResourceSliceSpec)(nil), (*resourcev1beta1.ResourceSliceSpec)(nil), func(a, b interface{}, scope conversion.Scope) error {
		return Convert_v1beta2_ResourceSliceSpec_To_v1beta1_ResourceSliceSpec(a.(*v1beta2.ResourceSliceSpec), b.(*resourcev1beta1.ResourceSliceSpec), scope)
	}); err != nil {
		return err
	}
	return nil
}

func autoConvert_v1beta2_AllocatedDeviceStatus_To_v1beta1_AllocatedDeviceStatus(in *v1beta2.AllocatedDeviceStatus, out *resourcev1beta1.AllocatedDeviceStatus, s conversion.Scope) error {
	out.Driver = in.Driver
	out.Pool = in.Pool
	out.Device = in.Device
	out.Conditions = *(*[]v1.Condition)(unsafe.Pointer(&in.Conditions))
	out.Data = (*runtime.RawExtension)(unsafe.Pointer(in.Data))
	out.NetworkData = (*resourcev1beta1.NetworkDeviceData)(unsafe.Pointer(in.NetworkData))
	return nil
}

// Convert_v1beta2_AllocatedDeviceStatus_To_v1beta1_AllocatedDeviceStatus is an autogenerated conversion function.
func Convert_v1beta2_AllocatedDeviceStatus_To_v1beta1_AllocatedDeviceStatus(in *v1beta2.AllocatedDeviceStatus, out *resourcev1beta1.AllocatedDeviceStatus, s conversion.Scope) error {
	return autoConvert_v1beta2_AllocatedDeviceStatus_To_v1beta1_AllocatedDeviceStatus(in, out, s)
}

func autoConvert_v1beta1_AllocatedDeviceStatus_To_v1beta2_AllocatedDeviceStatus(in *resourcev1beta1.AllocatedDeviceStatus, out *v1beta2.AllocatedDeviceStatus, s conversion.Scope) error {
	out.Driver = in.Driver
	out.Pool = in.Pool
	out.Device = in.Device
	out.Conditions = *(*[]v1.Condition)(unsafe.Pointer(&in.Conditions))
	out.Data = (*runtime.RawExtension)(unsafe.Pointer(in.Data))
	out.NetworkData = (*v1beta2.NetworkDeviceData)(unsafe.Pointer(in.NetworkData))
	return nil
}

// Convert_v1beta1_AllocatedDeviceStatus_To_v1beta2_AllocatedDeviceStatus is an autogenerated conversion function.
func Convert_v1beta1_AllocatedDeviceStatus_To_v1beta2_AllocatedDeviceStatus(in *resourcev1beta1.AllocatedDeviceStatus, out *v1beta2.AllocatedDeviceStatus, s conversion.Scope) error {
	return autoConvert_v1beta1_AllocatedDeviceStatus_To_v1beta2_AllocatedDeviceStatus(in, out, s)
}

func autoConvert_v1beta2_AllocationResult_To_v1beta1_AllocationResult(in *v1beta2.AllocationResult, out *resourcev1beta1.AllocationResult, s conversion.Scope) error {
	if err := Convert_v1beta2_DeviceAllocationResult_To_v1beta1_DeviceAllocationResult(&in.Devices, &out.Devices, s); err != nil {
		return err
	}
	out.NodeSelector = (*corev1.NodeSelector)(unsafe.Pointer(in.NodeSelector))
	return nil
}

// Convert_v1beta2_AllocationResult_To_v1beta1_AllocationResult is an autogenerated conversion function.
func Convert_v1beta2_AllocationResult_To_v1beta1_AllocationResult(in *v1beta2.AllocationResult, out *resourcev1beta1.AllocationResult, s conversion.Scope) error {
	return autoConvert_v1beta2_AllocationResult_To_v1beta1_AllocationResult(in, out, s)
}

func autoConvert_v1beta1_AllocationResult_To_v1beta2_AllocationResult(in *resourcev1beta1.AllocationResult, out *v1beta2.AllocationResult, s conversion.Scope) error {
	if err := Convert_v1beta1_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult(&in.Devices, &out.Devices, s); err != nil {
		return err
	}
	out.NodeSelector = (*corev1.NodeSelector)(unsafe.Pointer(in.NodeSelector))
	return nil
}

// Convert_v1beta1_AllocationResult_To_v1beta2_AllocationResult is an autogenerated conversion function.
func Convert_v1beta1_AllocationResult_To_v1beta2_AllocationResult(in *resourcev1beta1.AllocationResult, out *v1beta2.AllocationResult, s conversion.Scope) error {
	return autoConvert_v1beta1_AllocationResult_To_v1beta2_AllocationResult(in, out, s)
}

func autoConvert_v1beta2_CELDeviceSelector_To_v1beta1_CELDeviceSelector(in *v1beta2.CELDeviceSelector, out *resourcev1beta1.CELDeviceSelector, s conversion.Scope) error {
	out.Expression = in.Expression
	return nil
}

// Convert_v1beta2_CELDeviceSelector_To_v1beta1_CELDeviceSelector is an autogenerated conversion function.
func Convert_v1beta2_CELDeviceSelector_To_v1beta1_CELDeviceSelector(in *v1beta2.CELDeviceSelector, out *resourcev1beta1.CELDeviceSelector, s conversion.Scope) error {
	return autoConvert_v1beta2_CELDeviceSelector_To_v1beta1_CELDeviceSelector(in, out, s)
}

func autoConvert_v1beta1_CELDeviceSelector_To_v1beta2_CELDeviceSelector(in *resourcev1beta1.CELDeviceSelector, out *v1beta2.CELDeviceSelector, s conversion.Scope) error {
	out.Expression = in.Expression
	return nil
}

// Convert_v1beta1_CELDeviceSelector_To_v1beta2_CELDeviceSelector is an autogenerated conversion function.
func Convert_v1beta1_CELDeviceSelector_To_v1beta2_CELDeviceSelector(in *resourcev1beta1.CELDeviceSelector, out *v1beta2.CELDeviceSelector, s conversion.Scope) error {
	return autoConvert_v1beta1_CELDeviceSelector_To_v1beta2_CELDeviceSelector(in, out, s)
}

func autoConvert_v1beta2_Counter_To_v1beta1_Counter(in *v1beta2.Counter, out *resourcev1beta1.Counter, s conversion.Scope) error {
	out.Value = in.Value
	return nil
}

// Convert_v1beta2_Counter_To_v1beta1_Counter is an autogenerated conversion function.
func Convert_v1beta2_Counter_To_v1beta1_Counter(in *v1beta2.Counter, out *resourcev1beta1.Counter, s conversion.Scope) error {
	return autoConvert_v1beta2_Counter_To_v1beta1_Counter(in, out, s)
}

func autoConvert_v1beta1_Counter_To_v1beta2_Counter(in *resourcev1beta1.Counter, out *v1beta2.Counter, s conversion.Scope) error {
	out.Value = in.Value
	return nil
}

// Convert_v1beta1_Counter_To_v1beta2_Counter is an autogenerated conversion function.
func Convert_v1beta1_Counter_To_v1beta2_Counter(in *resourcev1beta1.Counter, out *v1beta2.Counter, s conversion.Scope) error {
	return autoConvert_v1beta1_Counter_To_v1beta2_Counter(in, out, s)
}

func autoConvert_v1beta2_CounterSet_To_v1beta1_CounterSet(in *v1beta2.CounterSet, out *resourcev1beta1.CounterSet, s conversion.Scope) error {
	out.Name = in.Name
	out.Counters = *(*map[string]resourcev1beta1.Counter)(unsafe.Pointer(&in.Counters))
	return nil
}

// Convert_v1beta2_CounterSet_To_v1beta1_CounterSet is an autogenerated conversion function.
func Convert_v1beta2_CounterSet_To_v1beta1_CounterSet(in *v1beta2.CounterSet, out *resourcev1beta1.CounterSet, s conversion.Scope) error {
	return autoConvert_v1beta2_CounterSet_To_v1beta1_CounterSet(in, out, s)
}

func autoConvert_v1beta1_CounterSet_To_v1beta2_CounterSet(in *resourcev1beta1.CounterSet, out *v1beta2.CounterSet, s conversion.Scope) error {
	out.Name = in.Name
	out.Counters = *(*map[string]v1beta2.Counter)(unsafe.Pointer(&in.Counters))
	return nil
}

// Convert_v1beta1_CounterSet_To_v1beta2_CounterSet is an autogenerated conversion function.
func Convert_v1beta1_CounterSet_To_v1beta2_CounterSet(in *resourcev1beta1.CounterSet, out *v1beta2.CounterSet, s conversion.Scope) error {
	return autoConvert_v1beta1_CounterSet_To_v1beta2_CounterSet(in, out, s)
}

func autoConvert_v1beta2_Device_To_v1beta1_Device(in *v1beta2.Device, out *resourcev1beta1.Device, s conversion.Scope) error {
	out.Name = in.Name
	// WARNING: in.Attributes requires manual conversion: does not exist in peer-type
	// WARNING: in.Capacity requires manual conversion: does not exist in peer-type
	// WARNING: in.ConsumesCounters requires manual conversion: does not exist in peer-type
	// WARNING: in.NodeName requires manual conversion: does not exist in peer-type
	// WARNING: in.NodeSelector requires manual conversion: does not exist in peer-type
	// WARNING: in.AllNodes requires manual conversion: does not exist in peer-type
	// WARNING: in.Taints requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1beta1_Device_To_v1beta2_Device(in *resourcev1beta1.Device, out *v1beta2.Device, s conversion.Scope) error {
	out.Name = in.Name
	// WARNING: in.Basic requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1beta2_DeviceAllocationConfiguration_To_v1beta1_DeviceAllocationConfiguration(in *v1beta2.DeviceAllocationConfiguration, out *resourcev1beta1.DeviceAllocationConfiguration, s conversion.Scope) error {
	out.Source = resourcev1beta1.AllocationConfigSource(in.Source)
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	if err := Convert_v1beta2_DeviceConfiguration_To_v1beta1_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_DeviceAllocationConfiguration_To_v1beta1_DeviceAllocationConfiguration is an autogenerated conversion function.
func Convert_v1beta2_DeviceAllocationConfiguration_To_v1beta1_DeviceAllocationConfiguration(in *v1beta2.DeviceAllocationConfiguration, out *resourcev1beta1.DeviceAllocationConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceAllocationConfiguration_To_v1beta1_DeviceAllocationConfiguration(in, out, s)
}

func autoConvert_v1beta1_DeviceAllocationConfiguration_To_v1beta2_DeviceAllocationConfiguration(in *resourcev1beta1.DeviceAllocationConfiguration, out *v1beta2.DeviceAllocationConfiguration, s conversion.Scope) error {
	out.Source = v1beta2.AllocationConfigSource(in.Source)
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	if err := Convert_v1beta1_DeviceConfiguration_To_v1beta2_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta1_DeviceAllocationConfiguration_To_v1beta2_DeviceAllocationConfiguration is an autogenerated conversion function.
func Convert_v1beta1_DeviceAllocationConfiguration_To_v1beta2_DeviceAllocationConfiguration(in *resourcev1beta1.DeviceAllocationConfiguration, out *v1beta2.DeviceAllocationConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceAllocationConfiguration_To_v1beta2_DeviceAllocationConfiguration(in, out, s)
}

func autoConvert_v1beta2_DeviceAllocationResult_To_v1beta1_DeviceAllocationResult(in *v1beta2.DeviceAllocationResult, out *resourcev1beta1.DeviceAllocationResult, s conversion.Scope) error {
	out.Results = *(*[]resourcev1beta1.DeviceRequestAllocationResult)(unsafe.Pointer(&in.Results))
	out.Config = *(*[]resourcev1beta1.DeviceAllocationConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_v1beta2_DeviceAllocationResult_To_v1beta1_DeviceAllocationResult is an autogenerated conversion function.
func Convert_v1beta2_DeviceAllocationResult_To_v1beta1_DeviceAllocationResult(in *v1beta2.DeviceAllocationResult, out *resourcev1beta1.DeviceAllocationResult, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceAllocationResult_To_v1beta1_DeviceAllocationResult(in, out, s)
}

func autoConvert_v1beta1_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult(in *resourcev1beta1.DeviceAllocationResult, out *v1beta2.DeviceAllocationResult, s conversion.Scope) error {
	out.Results = *(*[]v1beta2.DeviceRequestAllocationResult)(unsafe.Pointer(&in.Results))
	out.Config = *(*[]v1beta2.DeviceAllocationConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_v1beta1_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult is an autogenerated conversion function.
func Convert_v1beta1_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult(in *resourcev1beta1.DeviceAllocationResult, out *v1beta2.DeviceAllocationResult, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceAllocationResult_To_v1beta2_DeviceAllocationResult(in, out, s)
}

func autoConvert_v1beta2_DeviceAttribute_To_v1beta1_DeviceAttribute(in *v1beta2.DeviceAttribute, out *resourcev1beta1.DeviceAttribute, s conversion.Scope) error {
	out.IntValue = (*int64)(unsafe.Pointer(in.IntValue))
	out.BoolValue = (*bool)(unsafe.Pointer(in.BoolValue))
	out.StringValue = (*string)(unsafe.Pointer(in.StringValue))
	out.VersionValue = (*string)(unsafe.Pointer(in.VersionValue))
	return nil
}

// Convert_v1beta2_DeviceAttribute_To_v1beta1_DeviceAttribute is an autogenerated conversion function.
func Convert_v1beta2_DeviceAttribute_To_v1beta1_DeviceAttribute(in *v1beta2.DeviceAttribute, out *resourcev1beta1.DeviceAttribute, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceAttribute_To_v1beta1_DeviceAttribute(in, out, s)
}

func autoConvert_v1beta1_DeviceAttribute_To_v1beta2_DeviceAttribute(in *resourcev1beta1.DeviceAttribute, out *v1beta2.DeviceAttribute, s conversion.Scope) error {
	out.IntValue = (*int64)(unsafe.Pointer(in.IntValue))
	out.BoolValue = (*bool)(unsafe.Pointer(in.BoolValue))
	out.StringValue = (*string)(unsafe.Pointer(in.StringValue))
	out.VersionValue = (*string)(unsafe.Pointer(in.VersionValue))
	return nil
}

// Convert_v1beta1_DeviceAttribute_To_v1beta2_DeviceAttribute is an autogenerated conversion function.
func Convert_v1beta1_DeviceAttribute_To_v1beta2_DeviceAttribute(in *resourcev1beta1.DeviceAttribute, out *v1beta2.DeviceAttribute, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceAttribute_To_v1beta2_DeviceAttribute(in, out, s)
}

func autoConvert_v1beta2_DeviceCapacity_To_v1beta1_DeviceCapacity(in *v1beta2.DeviceCapacity, out *resourcev1beta1.DeviceCapacity, s conversion.Scope) error {
	out.Value = in.Value
	return nil
}

// Convert_v1beta2_DeviceCapacity_To_v1beta1_DeviceCapacity is an autogenerated conversion function.
func Convert_v1beta2_DeviceCapacity_To_v1beta1_DeviceCapacity(in *v1beta2.DeviceCapacity, out *resourcev1beta1.DeviceCapacity, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceCapacity_To_v1beta1_DeviceCapacity(in, out, s)
}

func autoConvert_v1beta1_DeviceCapacity_To_v1beta2_DeviceCapacity(in *resourcev1beta1.DeviceCapacity, out *v1beta2.DeviceCapacity, s conversion.Scope) error {
	out.Value = in.Value
	return nil
}

// Convert_v1beta1_DeviceCapacity_To_v1beta2_DeviceCapacity is an autogenerated conversion function.
func Convert_v1beta1_DeviceCapacity_To_v1beta2_DeviceCapacity(in *resourcev1beta1.DeviceCapacity, out *v1beta2.DeviceCapacity, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceCapacity_To_v1beta2_DeviceCapacity(in, out, s)
}

func autoConvert_v1beta2_DeviceClaim_To_v1beta1_DeviceClaim(in *v1beta2.DeviceClaim, out *resourcev1beta1.DeviceClaim, s conversion.Scope) error {
	if in.Requests != nil {
		in, out := &in.Requests, &out.Requests
		*out = make([]resourcev1beta1.DeviceRequest, len(*in))
		for i := range *in {
			if err := Convert_v1beta2_DeviceRequest_To_v1beta1_DeviceRequest(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Requests = nil
	}
	out.Constraints = *(*[]resourcev1beta1.DeviceConstraint)(unsafe.Pointer(&in.Constraints))
	out.Config = *(*[]resourcev1beta1.DeviceClaimConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_v1beta2_DeviceClaim_To_v1beta1_DeviceClaim is an autogenerated conversion function.
func Convert_v1beta2_DeviceClaim_To_v1beta1_DeviceClaim(in *v1beta2.DeviceClaim, out *resourcev1beta1.DeviceClaim, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClaim_To_v1beta1_DeviceClaim(in, out, s)
}

func autoConvert_v1beta1_DeviceClaim_To_v1beta2_DeviceClaim(in *resourcev1beta1.DeviceClaim, out *v1beta2.DeviceClaim, s conversion.Scope) error {
	if in.Requests != nil {
		in, out := &in.Requests, &out.Requests
		*out = make([]v1beta2.DeviceRequest, len(*in))
		for i := range *in {
			if err := Convert_v1beta1_DeviceRequest_To_v1beta2_DeviceRequest(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Requests = nil
	}
	out.Constraints = *(*[]v1beta2.DeviceConstraint)(unsafe.Pointer(&in.Constraints))
	out.Config = *(*[]v1beta2.DeviceClaimConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_v1beta1_DeviceClaim_To_v1beta2_DeviceClaim is an autogenerated conversion function.
func Convert_v1beta1_DeviceClaim_To_v1beta2_DeviceClaim(in *resourcev1beta1.DeviceClaim, out *v1beta2.DeviceClaim, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceClaim_To_v1beta2_DeviceClaim(in, out, s)
}

func autoConvert_v1beta2_DeviceClaimConfiguration_To_v1beta1_DeviceClaimConfiguration(in *v1beta2.DeviceClaimConfiguration, out *resourcev1beta1.DeviceClaimConfiguration, s conversion.Scope) error {
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	if err := Convert_v1beta2_DeviceConfiguration_To_v1beta1_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_DeviceClaimConfiguration_To_v1beta1_DeviceClaimConfiguration is an autogenerated conversion function.
func Convert_v1beta2_DeviceClaimConfiguration_To_v1beta1_DeviceClaimConfiguration(in *v1beta2.DeviceClaimConfiguration, out *resourcev1beta1.DeviceClaimConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClaimConfiguration_To_v1beta1_DeviceClaimConfiguration(in, out, s)
}

func autoConvert_v1beta1_DeviceClaimConfiguration_To_v1beta2_DeviceClaimConfiguration(in *resourcev1beta1.DeviceClaimConfiguration, out *v1beta2.DeviceClaimConfiguration, s conversion.Scope) error {
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	if err := Convert_v1beta1_DeviceConfiguration_To_v1beta2_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta1_DeviceClaimConfiguration_To_v1beta2_DeviceClaimConfiguration is an autogenerated conversion function.
func Convert_v1beta1_DeviceClaimConfiguration_To_v1beta2_DeviceClaimConfiguration(in *resourcev1beta1.DeviceClaimConfiguration, out *v1beta2.DeviceClaimConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceClaimConfiguration_To_v1beta2_DeviceClaimConfiguration(in, out, s)
}

func autoConvert_v1beta2_DeviceClass_To_v1beta1_DeviceClass(in *v1beta2.DeviceClass, out *resourcev1beta1.DeviceClass, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta2_DeviceClassSpec_To_v1beta1_DeviceClassSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_DeviceClass_To_v1beta1_DeviceClass is an autogenerated conversion function.
func Convert_v1beta2_DeviceClass_To_v1beta1_DeviceClass(in *v1beta2.DeviceClass, out *resourcev1beta1.DeviceClass, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClass_To_v1beta1_DeviceClass(in, out, s)
}

func autoConvert_v1beta1_DeviceClass_To_v1beta2_DeviceClass(in *resourcev1beta1.DeviceClass, out *v1beta2.DeviceClass, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta1_DeviceClassSpec_To_v1beta2_DeviceClassSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta1_DeviceClass_To_v1beta2_DeviceClass is an autogenerated conversion function.
func Convert_v1beta1_DeviceClass_To_v1beta2_DeviceClass(in *resourcev1beta1.DeviceClass, out *v1beta2.DeviceClass, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceClass_To_v1beta2_DeviceClass(in, out, s)
}

func autoConvert_v1beta2_DeviceClassConfiguration_To_v1beta1_DeviceClassConfiguration(in *v1beta2.DeviceClassConfiguration, out *resourcev1beta1.DeviceClassConfiguration, s conversion.Scope) error {
	if err := Convert_v1beta2_DeviceConfiguration_To_v1beta1_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_DeviceClassConfiguration_To_v1beta1_DeviceClassConfiguration is an autogenerated conversion function.
func Convert_v1beta2_DeviceClassConfiguration_To_v1beta1_DeviceClassConfiguration(in *v1beta2.DeviceClassConfiguration, out *resourcev1beta1.DeviceClassConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClassConfiguration_To_v1beta1_DeviceClassConfiguration(in, out, s)
}

func autoConvert_v1beta1_DeviceClassConfiguration_To_v1beta2_DeviceClassConfiguration(in *resourcev1beta1.DeviceClassConfiguration, out *v1beta2.DeviceClassConfiguration, s conversion.Scope) error {
	if err := Convert_v1beta1_DeviceConfiguration_To_v1beta2_DeviceConfiguration(&in.DeviceConfiguration, &out.DeviceConfiguration, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta1_DeviceClassConfiguration_To_v1beta2_DeviceClassConfiguration is an autogenerated conversion function.
func Convert_v1beta1_DeviceClassConfiguration_To_v1beta2_DeviceClassConfiguration(in *resourcev1beta1.DeviceClassConfiguration, out *v1beta2.DeviceClassConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceClassConfiguration_To_v1beta2_DeviceClassConfiguration(in, out, s)
}

func autoConvert_v1beta2_DeviceClassList_To_v1beta1_DeviceClassList(in *v1beta2.DeviceClassList, out *resourcev1beta1.DeviceClassList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]resourcev1beta1.DeviceClass)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1beta2_DeviceClassList_To_v1beta1_DeviceClassList is an autogenerated conversion function.
func Convert_v1beta2_DeviceClassList_To_v1beta1_DeviceClassList(in *v1beta2.DeviceClassList, out *resourcev1beta1.DeviceClassList, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClassList_To_v1beta1_DeviceClassList(in, out, s)
}

func autoConvert_v1beta1_DeviceClassList_To_v1beta2_DeviceClassList(in *resourcev1beta1.DeviceClassList, out *v1beta2.DeviceClassList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	out.Items = *(*[]v1beta2.DeviceClass)(unsafe.Pointer(&in.Items))
	return nil
}

// Convert_v1beta1_DeviceClassList_To_v1beta2_DeviceClassList is an autogenerated conversion function.
func Convert_v1beta1_DeviceClassList_To_v1beta2_DeviceClassList(in *resourcev1beta1.DeviceClassList, out *v1beta2.DeviceClassList, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceClassList_To_v1beta2_DeviceClassList(in, out, s)
}

func autoConvert_v1beta2_DeviceClassSpec_To_v1beta1_DeviceClassSpec(in *v1beta2.DeviceClassSpec, out *resourcev1beta1.DeviceClassSpec, s conversion.Scope) error {
	out.Selectors = *(*[]resourcev1beta1.DeviceSelector)(unsafe.Pointer(&in.Selectors))
	out.Config = *(*[]resourcev1beta1.DeviceClassConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_v1beta2_DeviceClassSpec_To_v1beta1_DeviceClassSpec is an autogenerated conversion function.
func Convert_v1beta2_DeviceClassSpec_To_v1beta1_DeviceClassSpec(in *v1beta2.DeviceClassSpec, out *resourcev1beta1.DeviceClassSpec, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceClassSpec_To_v1beta1_DeviceClassSpec(in, out, s)
}

func autoConvert_v1beta1_DeviceClassSpec_To_v1beta2_DeviceClassSpec(in *resourcev1beta1.DeviceClassSpec, out *v1beta2.DeviceClassSpec, s conversion.Scope) error {
	out.Selectors = *(*[]v1beta2.DeviceSelector)(unsafe.Pointer(&in.Selectors))
	out.Config = *(*[]v1beta2.DeviceClassConfiguration)(unsafe.Pointer(&in.Config))
	return nil
}

// Convert_v1beta1_DeviceClassSpec_To_v1beta2_DeviceClassSpec is an autogenerated conversion function.
func Convert_v1beta1_DeviceClassSpec_To_v1beta2_DeviceClassSpec(in *resourcev1beta1.DeviceClassSpec, out *v1beta2.DeviceClassSpec, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceClassSpec_To_v1beta2_DeviceClassSpec(in, out, s)
}

func autoConvert_v1beta2_DeviceConfiguration_To_v1beta1_DeviceConfiguration(in *v1beta2.DeviceConfiguration, out *resourcev1beta1.DeviceConfiguration, s conversion.Scope) error {
	out.Opaque = (*resourcev1beta1.OpaqueDeviceConfiguration)(unsafe.Pointer(in.Opaque))
	return nil
}

// Convert_v1beta2_DeviceConfiguration_To_v1beta1_DeviceConfiguration is an autogenerated conversion function.
func Convert_v1beta2_DeviceConfiguration_To_v1beta1_DeviceConfiguration(in *v1beta2.DeviceConfiguration, out *resourcev1beta1.DeviceConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceConfiguration_To_v1beta1_DeviceConfiguration(in, out, s)
}

func autoConvert_v1beta1_DeviceConfiguration_To_v1beta2_DeviceConfiguration(in *resourcev1beta1.DeviceConfiguration, out *v1beta2.DeviceConfiguration, s conversion.Scope) error {
	out.Opaque = (*v1beta2.OpaqueDeviceConfiguration)(unsafe.Pointer(in.Opaque))
	return nil
}

// Convert_v1beta1_DeviceConfiguration_To_v1beta2_DeviceConfiguration is an autogenerated conversion function.
func Convert_v1beta1_DeviceConfiguration_To_v1beta2_DeviceConfiguration(in *resourcev1beta1.DeviceConfiguration, out *v1beta2.DeviceConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceConfiguration_To_v1beta2_DeviceConfiguration(in, out, s)
}

func autoConvert_v1beta2_DeviceConstraint_To_v1beta1_DeviceConstraint(in *v1beta2.DeviceConstraint, out *resourcev1beta1.DeviceConstraint, s conversion.Scope) error {
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	out.MatchAttribute = (*resourcev1beta1.FullyQualifiedName)(unsafe.Pointer(in.MatchAttribute))
	return nil
}

// Convert_v1beta2_DeviceConstraint_To_v1beta1_DeviceConstraint is an autogenerated conversion function.
func Convert_v1beta2_DeviceConstraint_To_v1beta1_DeviceConstraint(in *v1beta2.DeviceConstraint, out *resourcev1beta1.DeviceConstraint, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceConstraint_To_v1beta1_DeviceConstraint(in, out, s)
}

func autoConvert_v1beta1_DeviceConstraint_To_v1beta2_DeviceConstraint(in *resourcev1beta1.DeviceConstraint, out *v1beta2.DeviceConstraint, s conversion.Scope) error {
	out.Requests = *(*[]string)(unsafe.Pointer(&in.Requests))
	out.MatchAttribute = (*v1beta2.FullyQualifiedName)(unsafe.Pointer(in.MatchAttribute))
	return nil
}

// Convert_v1beta1_DeviceConstraint_To_v1beta2_DeviceConstraint is an autogenerated conversion function.
func Convert_v1beta1_DeviceConstraint_To_v1beta2_DeviceConstraint(in *resourcev1beta1.DeviceConstraint, out *v1beta2.DeviceConstraint, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceConstraint_To_v1beta2_DeviceConstraint(in, out, s)
}

func autoConvert_v1beta2_DeviceCounterConsumption_To_v1beta1_DeviceCounterConsumption(in *v1beta2.DeviceCounterConsumption, out *resourcev1beta1.DeviceCounterConsumption, s conversion.Scope) error {
	out.CounterSet = in.CounterSet
	out.Counters = *(*map[string]resourcev1beta1.Counter)(unsafe.Pointer(&in.Counters))
	return nil
}

// Convert_v1beta2_DeviceCounterConsumption_To_v1beta1_DeviceCounterConsumption is an autogenerated conversion function.
func Convert_v1beta2_DeviceCounterConsumption_To_v1beta1_DeviceCounterConsumption(in *v1beta2.DeviceCounterConsumption, out *resourcev1beta1.DeviceCounterConsumption, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceCounterConsumption_To_v1beta1_DeviceCounterConsumption(in, out, s)
}

func autoConvert_v1beta1_DeviceCounterConsumption_To_v1beta2_DeviceCounterConsumption(in *resourcev1beta1.DeviceCounterConsumption, out *v1beta2.DeviceCounterConsumption, s conversion.Scope) error {
	out.CounterSet = in.CounterSet
	out.Counters = *(*map[string]v1beta2.Counter)(unsafe.Pointer(&in.Counters))
	return nil
}

// Convert_v1beta1_DeviceCounterConsumption_To_v1beta2_DeviceCounterConsumption is an autogenerated conversion function.
func Convert_v1beta1_DeviceCounterConsumption_To_v1beta2_DeviceCounterConsumption(in *resourcev1beta1.DeviceCounterConsumption, out *v1beta2.DeviceCounterConsumption, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceCounterConsumption_To_v1beta2_DeviceCounterConsumption(in, out, s)
}

func autoConvert_v1beta2_DeviceRequest_To_v1beta1_DeviceRequest(in *v1beta2.DeviceRequest, out *resourcev1beta1.DeviceRequest, s conversion.Scope) error {
	out.Name = in.Name
	// WARNING: in.Exactly requires manual conversion: does not exist in peer-type
	out.FirstAvailable = *(*[]resourcev1beta1.DeviceSubRequest)(unsafe.Pointer(&in.FirstAvailable))
	return nil
}

func autoConvert_v1beta1_DeviceRequest_To_v1beta2_DeviceRequest(in *resourcev1beta1.DeviceRequest, out *v1beta2.DeviceRequest, s conversion.Scope) error {
	out.Name = in.Name
	// WARNING: in.DeviceClassName requires manual conversion: does not exist in peer-type
	// WARNING: in.Selectors requires manual conversion: does not exist in peer-type
	// WARNING: in.AllocationMode requires manual conversion: does not exist in peer-type
	// WARNING: in.Count requires manual conversion: does not exist in peer-type
	// WARNING: in.AdminAccess requires manual conversion: does not exist in peer-type
	out.FirstAvailable = *(*[]v1beta2.DeviceSubRequest)(unsafe.Pointer(&in.FirstAvailable))
	// WARNING: in.Tolerations requires manual conversion: does not exist in peer-type
	return nil
}

func autoConvert_v1beta2_DeviceRequestAllocationResult_To_v1beta1_DeviceRequestAllocationResult(in *v1beta2.DeviceRequestAllocationResult, out *resourcev1beta1.DeviceRequestAllocationResult, s conversion.Scope) error {
	out.Request = in.Request
	out.Driver = in.Driver
	out.Pool = in.Pool
	out.Device = in.Device
	out.AdminAccess = (*bool)(unsafe.Pointer(in.AdminAccess))
	out.Tolerations = *(*[]resourcev1beta1.DeviceToleration)(unsafe.Pointer(&in.Tolerations))
	return nil
}

// Convert_v1beta2_DeviceRequestAllocationResult_To_v1beta1_DeviceRequestAllocationResult is an autogenerated conversion function.
func Convert_v1beta2_DeviceRequestAllocationResult_To_v1beta1_DeviceRequestAllocationResult(in *v1beta2.DeviceRequestAllocationResult, out *resourcev1beta1.DeviceRequestAllocationResult, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceRequestAllocationResult_To_v1beta1_DeviceRequestAllocationResult(in, out, s)
}

func autoConvert_v1beta1_DeviceRequestAllocationResult_To_v1beta2_DeviceRequestAllocationResult(in *resourcev1beta1.DeviceRequestAllocationResult, out *v1beta2.DeviceRequestAllocationResult, s conversion.Scope) error {
	out.Request = in.Request
	out.Driver = in.Driver
	out.Pool = in.Pool
	out.Device = in.Device
	out.AdminAccess = (*bool)(unsafe.Pointer(in.AdminAccess))
	out.Tolerations = *(*[]v1beta2.DeviceToleration)(unsafe.Pointer(&in.Tolerations))
	return nil
}

// Convert_v1beta1_DeviceRequestAllocationResult_To_v1beta2_DeviceRequestAllocationResult is an autogenerated conversion function.
func Convert_v1beta1_DeviceRequestAllocationResult_To_v1beta2_DeviceRequestAllocationResult(in *resourcev1beta1.DeviceRequestAllocationResult, out *v1beta2.DeviceRequestAllocationResult, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceRequestAllocationResult_To_v1beta2_DeviceRequestAllocationResult(in, out, s)
}

func autoConvert_v1beta2_DeviceSelector_To_v1beta1_DeviceSelector(in *v1beta2.DeviceSelector, out *resourcev1beta1.DeviceSelector, s conversion.Scope) error {
	out.CEL = (*resourcev1beta1.CELDeviceSelector)(unsafe.Pointer(in.CEL))
	return nil
}

// Convert_v1beta2_DeviceSelector_To_v1beta1_DeviceSelector is an autogenerated conversion function.
func Convert_v1beta2_DeviceSelector_To_v1beta1_DeviceSelector(in *v1beta2.DeviceSelector, out *resourcev1beta1.DeviceSelector, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceSelector_To_v1beta1_DeviceSelector(in, out, s)
}

func autoConvert_v1beta1_DeviceSelector_To_v1beta2_DeviceSelector(in *resourcev1beta1.DeviceSelector, out *v1beta2.DeviceSelector, s conversion.Scope) error {
	out.CEL = (*v1beta2.CELDeviceSelector)(unsafe.Pointer(in.CEL))
	return nil
}

// Convert_v1beta1_DeviceSelector_To_v1beta2_DeviceSelector is an autogenerated conversion function.
func Convert_v1beta1_DeviceSelector_To_v1beta2_DeviceSelector(in *resourcev1beta1.DeviceSelector, out *v1beta2.DeviceSelector, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceSelector_To_v1beta2_DeviceSelector(in, out, s)
}

func autoConvert_v1beta2_DeviceSubRequest_To_v1beta1_DeviceSubRequest(in *v1beta2.DeviceSubRequest, out *resourcev1beta1.DeviceSubRequest, s conversion.Scope) error {
	out.Name = in.Name
	out.DeviceClassName = in.DeviceClassName
	out.Selectors = *(*[]resourcev1beta1.DeviceSelector)(unsafe.Pointer(&in.Selectors))
	out.AllocationMode = resourcev1beta1.DeviceAllocationMode(in.AllocationMode)
	out.Count = in.Count
	out.Tolerations = *(*[]resourcev1beta1.DeviceToleration)(unsafe.Pointer(&in.Tolerations))
	return nil
}

// Convert_v1beta2_DeviceSubRequest_To_v1beta1_DeviceSubRequest is an autogenerated conversion function.
func Convert_v1beta2_DeviceSubRequest_To_v1beta1_DeviceSubRequest(in *v1beta2.DeviceSubRequest, out *resourcev1beta1.DeviceSubRequest, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceSubRequest_To_v1beta1_DeviceSubRequest(in, out, s)
}

func autoConvert_v1beta1_DeviceSubRequest_To_v1beta2_DeviceSubRequest(in *resourcev1beta1.DeviceSubRequest, out *v1beta2.DeviceSubRequest, s conversion.Scope) error {
	out.Name = in.Name
	out.DeviceClassName = in.DeviceClassName
	out.Selectors = *(*[]v1beta2.DeviceSelector)(unsafe.Pointer(&in.Selectors))
	out.AllocationMode = v1beta2.DeviceAllocationMode(in.AllocationMode)
	out.Count = in.Count
	out.Tolerations = *(*[]v1beta2.DeviceToleration)(unsafe.Pointer(&in.Tolerations))
	return nil
}

// Convert_v1beta1_DeviceSubRequest_To_v1beta2_DeviceSubRequest is an autogenerated conversion function.
func Convert_v1beta1_DeviceSubRequest_To_v1beta2_DeviceSubRequest(in *resourcev1beta1.DeviceSubRequest, out *v1beta2.DeviceSubRequest, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceSubRequest_To_v1beta2_DeviceSubRequest(in, out, s)
}

func autoConvert_v1beta2_DeviceTaint_To_v1beta1_DeviceTaint(in *v1beta2.DeviceTaint, out *resourcev1beta1.DeviceTaint, s conversion.Scope) error {
	out.Key = in.Key
	out.Value = in.Value
	out.Effect = resourcev1beta1.DeviceTaintEffect(in.Effect)
	out.TimeAdded = (*v1.Time)(unsafe.Pointer(in.TimeAdded))
	return nil
}

// Convert_v1beta2_DeviceTaint_To_v1beta1_DeviceTaint is an autogenerated conversion function.
func Convert_v1beta2_DeviceTaint_To_v1beta1_DeviceTaint(in *v1beta2.DeviceTaint, out *resourcev1beta1.DeviceTaint, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceTaint_To_v1beta1_DeviceTaint(in, out, s)
}

func autoConvert_v1beta1_DeviceTaint_To_v1beta2_DeviceTaint(in *resourcev1beta1.DeviceTaint, out *v1beta2.DeviceTaint, s conversion.Scope) error {
	out.Key = in.Key
	out.Value = in.Value
	out.Effect = v1beta2.DeviceTaintEffect(in.Effect)
	out.TimeAdded = (*v1.Time)(unsafe.Pointer(in.TimeAdded))
	return nil
}

// Convert_v1beta1_DeviceTaint_To_v1beta2_DeviceTaint is an autogenerated conversion function.
func Convert_v1beta1_DeviceTaint_To_v1beta2_DeviceTaint(in *resourcev1beta1.DeviceTaint, out *v1beta2.DeviceTaint, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceTaint_To_v1beta2_DeviceTaint(in, out, s)
}

func autoConvert_v1beta2_DeviceToleration_To_v1beta1_DeviceToleration(in *v1beta2.DeviceToleration, out *resourcev1beta1.DeviceToleration, s conversion.Scope) error {
	out.Key = in.Key
	out.Operator = resourcev1beta1.DeviceTolerationOperator(in.Operator)
	out.Value = in.Value
	out.Effect = resourcev1beta1.DeviceTaintEffect(in.Effect)
	out.TolerationSeconds = (*int64)(unsafe.Pointer(in.TolerationSeconds))
	return nil
}

// Convert_v1beta2_DeviceToleration_To_v1beta1_DeviceToleration is an autogenerated conversion function.
func Convert_v1beta2_DeviceToleration_To_v1beta1_DeviceToleration(in *v1beta2.DeviceToleration, out *resourcev1beta1.DeviceToleration, s conversion.Scope) error {
	return autoConvert_v1beta2_DeviceToleration_To_v1beta1_DeviceToleration(in, out, s)
}

func autoConvert_v1beta1_DeviceToleration_To_v1beta2_DeviceToleration(in *resourcev1beta1.DeviceToleration, out *v1beta2.DeviceToleration, s conversion.Scope) error {
	out.Key = in.Key
	out.Operator = v1beta2.DeviceTolerationOperator(in.Operator)
	out.Value = in.Value
	out.Effect = v1beta2.DeviceTaintEffect(in.Effect)
	out.TolerationSeconds = (*int64)(unsafe.Pointer(in.TolerationSeconds))
	return nil
}

// Convert_v1beta1_DeviceToleration_To_v1beta2_DeviceToleration is an autogenerated conversion function.
func Convert_v1beta1_DeviceToleration_To_v1beta2_DeviceToleration(in *resourcev1beta1.DeviceToleration, out *v1beta2.DeviceToleration, s conversion.Scope) error {
	return autoConvert_v1beta1_DeviceToleration_To_v1beta2_DeviceToleration(in, out, s)
}

func autoConvert_v1beta2_NetworkDeviceData_To_v1beta1_NetworkDeviceData(in *v1beta2.NetworkDeviceData, out *resourcev1beta1.NetworkDeviceData, s conversion.Scope) error {
	out.InterfaceName = in.InterfaceName
	out.IPs = *(*[]string)(unsafe.Pointer(&in.IPs))
	out.HardwareAddress = in.HardwareAddress
	return nil
}

// Convert_v1beta2_NetworkDeviceData_To_v1beta1_NetworkDeviceData is an autogenerated conversion function.
func Convert_v1beta2_NetworkDeviceData_To_v1beta1_NetworkDeviceData(in *v1beta2.NetworkDeviceData, out *resourcev1beta1.NetworkDeviceData, s conversion.Scope) error {
	return autoConvert_v1beta2_NetworkDeviceData_To_v1beta1_NetworkDeviceData(in, out, s)
}

func autoConvert_v1beta1_NetworkDeviceData_To_v1beta2_NetworkDeviceData(in *resourcev1beta1.NetworkDeviceData, out *v1beta2.NetworkDeviceData, s conversion.Scope) error {
	out.InterfaceName = in.InterfaceName
	out.IPs = *(*[]string)(unsafe.Pointer(&in.IPs))
	out.HardwareAddress = in.HardwareAddress
	return nil
}

// Convert_v1beta1_NetworkDeviceData_To_v1beta2_NetworkDeviceData is an autogenerated conversion function.
func Convert_v1beta1_NetworkDeviceData_To_v1beta2_NetworkDeviceData(in *resourcev1beta1.NetworkDeviceData, out *v1beta2.NetworkDeviceData, s conversion.Scope) error {
	return autoConvert_v1beta1_NetworkDeviceData_To_v1beta2_NetworkDeviceData(in, out, s)
}

func autoConvert_v1beta2_OpaqueDeviceConfiguration_To_v1beta1_OpaqueDeviceConfiguration(in *v1beta2.OpaqueDeviceConfiguration, out *resourcev1beta1.OpaqueDeviceConfiguration, s conversion.Scope) error {
	out.Driver = in.Driver
	out.Parameters = in.Parameters
	return nil
}

// Convert_v1beta2_OpaqueDeviceConfiguration_To_v1beta1_OpaqueDeviceConfiguration is an autogenerated conversion function.
func Convert_v1beta2_OpaqueDeviceConfiguration_To_v1beta1_OpaqueDeviceConfiguration(in *v1beta2.OpaqueDeviceConfiguration, out *resourcev1beta1.OpaqueDeviceConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta2_OpaqueDeviceConfiguration_To_v1beta1_OpaqueDeviceConfiguration(in, out, s)
}

func autoConvert_v1beta1_OpaqueDeviceConfiguration_To_v1beta2_OpaqueDeviceConfiguration(in *resourcev1beta1.OpaqueDeviceConfiguration, out *v1beta2.OpaqueDeviceConfiguration, s conversion.Scope) error {
	out.Driver = in.Driver
	out.Parameters = in.Parameters
	return nil
}

// Convert_v1beta1_OpaqueDeviceConfiguration_To_v1beta2_OpaqueDeviceConfiguration is an autogenerated conversion function.
func Convert_v1beta1_OpaqueDeviceConfiguration_To_v1beta2_OpaqueDeviceConfiguration(in *resourcev1beta1.OpaqueDeviceConfiguration, out *v1beta2.OpaqueDeviceConfiguration, s conversion.Scope) error {
	return autoConvert_v1beta1_OpaqueDeviceConfiguration_To_v1beta2_OpaqueDeviceConfiguration(in, out, s)
}

func autoConvert_v1beta2_ResourceClaim_To_v1beta1_ResourceClaim(in *v1beta2.ResourceClaim, out *resourcev1beta1.ResourceClaim, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta2_ResourceClaimSpec_To_v1beta1_ResourceClaimSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1beta2_ResourceClaimStatus_To_v1beta1_ResourceClaimStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_ResourceClaim_To_v1beta1_ResourceClaim is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaim_To_v1beta1_ResourceClaim(in *v1beta2.ResourceClaim, out *resourcev1beta1.ResourceClaim, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaim_To_v1beta1_ResourceClaim(in, out, s)
}

func autoConvert_v1beta1_ResourceClaim_To_v1beta2_ResourceClaim(in *resourcev1beta1.ResourceClaim, out *v1beta2.ResourceClaim, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta1_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	if err := Convert_v1beta1_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus(&in.Status, &out.Status, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta1_ResourceClaim_To_v1beta2_ResourceClaim is an autogenerated conversion function.
func Convert_v1beta1_ResourceClaim_To_v1beta2_ResourceClaim(in *resourcev1beta1.ResourceClaim, out *v1beta2.ResourceClaim, s conversion.Scope) error {
	return autoConvert_v1beta1_ResourceClaim_To_v1beta2_ResourceClaim(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimConsumerReference_To_v1beta1_ResourceClaimConsumerReference(in *v1beta2.ResourceClaimConsumerReference, out *resourcev1beta1.ResourceClaimConsumerReference, s conversion.Scope) error {
	out.APIGroup = in.APIGroup
	out.Resource = in.Resource
	out.Name = in.Name
	out.UID = types.UID(in.UID)
	return nil
}

// Convert_v1beta2_ResourceClaimConsumerReference_To_v1beta1_ResourceClaimConsumerReference is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimConsumerReference_To_v1beta1_ResourceClaimConsumerReference(in *v1beta2.ResourceClaimConsumerReference, out *resourcev1beta1.ResourceClaimConsumerReference, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimConsumerReference_To_v1beta1_ResourceClaimConsumerReference(in, out, s)
}

func autoConvert_v1beta1_ResourceClaimConsumerReference_To_v1beta2_ResourceClaimConsumerReference(in *resourcev1beta1.ResourceClaimConsumerReference, out *v1beta2.ResourceClaimConsumerReference, s conversion.Scope) error {
	out.APIGroup = in.APIGroup
	out.Resource = in.Resource
	out.Name = in.Name
	out.UID = types.UID(in.UID)
	return nil
}

// Convert_v1beta1_ResourceClaimConsumerReference_To_v1beta2_ResourceClaimConsumerReference is an autogenerated conversion function.
func Convert_v1beta1_ResourceClaimConsumerReference_To_v1beta2_ResourceClaimConsumerReference(in *resourcev1beta1.ResourceClaimConsumerReference, out *v1beta2.ResourceClaimConsumerReference, s conversion.Scope) error {
	return autoConvert_v1beta1_ResourceClaimConsumerReference_To_v1beta2_ResourceClaimConsumerReference(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimList_To_v1beta1_ResourceClaimList(in *v1beta2.ResourceClaimList, out *resourcev1beta1.ResourceClaimList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]resourcev1beta1.ResourceClaim, len(*in))
		for i := range *in {
			if err := Convert_v1beta2_ResourceClaim_To_v1beta1_ResourceClaim(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1beta2_ResourceClaimList_To_v1beta1_ResourceClaimList is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimList_To_v1beta1_ResourceClaimList(in *v1beta2.ResourceClaimList, out *resourcev1beta1.ResourceClaimList, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimList_To_v1beta1_ResourceClaimList(in, out, s)
}

func autoConvert_v1beta1_ResourceClaimList_To_v1beta2_ResourceClaimList(in *resourcev1beta1.ResourceClaimList, out *v1beta2.ResourceClaimList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]v1beta2.ResourceClaim, len(*in))
		for i := range *in {
			if err := Convert_v1beta1_ResourceClaim_To_v1beta2_ResourceClaim(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1beta1_ResourceClaimList_To_v1beta2_ResourceClaimList is an autogenerated conversion function.
func Convert_v1beta1_ResourceClaimList_To_v1beta2_ResourceClaimList(in *resourcev1beta1.ResourceClaimList, out *v1beta2.ResourceClaimList, s conversion.Scope) error {
	return autoConvert_v1beta1_ResourceClaimList_To_v1beta2_ResourceClaimList(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimSpec_To_v1beta1_ResourceClaimSpec(in *v1beta2.ResourceClaimSpec, out *resourcev1beta1.ResourceClaimSpec, s conversion.Scope) error {
	if err := Convert_v1beta2_DeviceClaim_To_v1beta1_DeviceClaim(&in.Devices, &out.Devices, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_ResourceClaimSpec_To_v1beta1_ResourceClaimSpec is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimSpec_To_v1beta1_ResourceClaimSpec(in *v1beta2.ResourceClaimSpec, out *resourcev1beta1.ResourceClaimSpec, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimSpec_To_v1beta1_ResourceClaimSpec(in, out, s)
}

func autoConvert_v1beta1_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(in *resourcev1beta1.ResourceClaimSpec, out *v1beta2.ResourceClaimSpec, s conversion.Scope) error {
	if err := Convert_v1beta1_DeviceClaim_To_v1beta2_DeviceClaim(&in.Devices, &out.Devices, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta1_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec is an autogenerated conversion function.
func Convert_v1beta1_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(in *resourcev1beta1.ResourceClaimSpec, out *v1beta2.ResourceClaimSpec, s conversion.Scope) error {
	return autoConvert_v1beta1_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimStatus_To_v1beta1_ResourceClaimStatus(in *v1beta2.ResourceClaimStatus, out *resourcev1beta1.ResourceClaimStatus, s conversion.Scope) error {
	out.Allocation = (*resourcev1beta1.AllocationResult)(unsafe.Pointer(in.Allocation))
	out.ReservedFor = *(*[]resourcev1beta1.ResourceClaimConsumerReference)(unsafe.Pointer(&in.ReservedFor))
	out.Devices = *(*[]resourcev1beta1.AllocatedDeviceStatus)(unsafe.Pointer(&in.Devices))
	return nil
}

// Convert_v1beta2_ResourceClaimStatus_To_v1beta1_ResourceClaimStatus is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimStatus_To_v1beta1_ResourceClaimStatus(in *v1beta2.ResourceClaimStatus, out *resourcev1beta1.ResourceClaimStatus, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimStatus_To_v1beta1_ResourceClaimStatus(in, out, s)
}

func autoConvert_v1beta1_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus(in *resourcev1beta1.ResourceClaimStatus, out *v1beta2.ResourceClaimStatus, s conversion.Scope) error {
	out.Allocation = (*v1beta2.AllocationResult)(unsafe.Pointer(in.Allocation))
	out.ReservedFor = *(*[]v1beta2.ResourceClaimConsumerReference)(unsafe.Pointer(&in.ReservedFor))
	out.Devices = *(*[]v1beta2.AllocatedDeviceStatus)(unsafe.Pointer(&in.Devices))
	return nil
}

// Convert_v1beta1_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus is an autogenerated conversion function.
func Convert_v1beta1_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus(in *resourcev1beta1.ResourceClaimStatus, out *v1beta2.ResourceClaimStatus, s conversion.Scope) error {
	return autoConvert_v1beta1_ResourceClaimStatus_To_v1beta2_ResourceClaimStatus(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimTemplate_To_v1beta1_ResourceClaimTemplate(in *v1beta2.ResourceClaimTemplate, out *resourcev1beta1.ResourceClaimTemplate, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta2_ResourceClaimTemplateSpec_To_v1beta1_ResourceClaimTemplateSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_ResourceClaimTemplate_To_v1beta1_ResourceClaimTemplate is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimTemplate_To_v1beta1_ResourceClaimTemplate(in *v1beta2.ResourceClaimTemplate, out *resourcev1beta1.ResourceClaimTemplate, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimTemplate_To_v1beta1_ResourceClaimTemplate(in, out, s)
}

func autoConvert_v1beta1_ResourceClaimTemplate_To_v1beta2_ResourceClaimTemplate(in *resourcev1beta1.ResourceClaimTemplate, out *v1beta2.ResourceClaimTemplate, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta1_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta1_ResourceClaimTemplate_To_v1beta2_ResourceClaimTemplate is an autogenerated conversion function.
func Convert_v1beta1_ResourceClaimTemplate_To_v1beta2_ResourceClaimTemplate(in *resourcev1beta1.ResourceClaimTemplate, out *v1beta2.ResourceClaimTemplate, s conversion.Scope) error {
	return autoConvert_v1beta1_ResourceClaimTemplate_To_v1beta2_ResourceClaimTemplate(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimTemplateList_To_v1beta1_ResourceClaimTemplateList(in *v1beta2.ResourceClaimTemplateList, out *resourcev1beta1.ResourceClaimTemplateList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]resourcev1beta1.ResourceClaimTemplate, len(*in))
		for i := range *in {
			if err := Convert_v1beta2_ResourceClaimTemplate_To_v1beta1_ResourceClaimTemplate(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1beta2_ResourceClaimTemplateList_To_v1beta1_ResourceClaimTemplateList is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimTemplateList_To_v1beta1_ResourceClaimTemplateList(in *v1beta2.ResourceClaimTemplateList, out *resourcev1beta1.ResourceClaimTemplateList, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimTemplateList_To_v1beta1_ResourceClaimTemplateList(in, out, s)
}

func autoConvert_v1beta1_ResourceClaimTemplateList_To_v1beta2_ResourceClaimTemplateList(in *resourcev1beta1.ResourceClaimTemplateList, out *v1beta2.ResourceClaimTemplateList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]v1beta2.ResourceClaimTemplate, len(*in))
		for i := range *in {
			if err := Convert_v1beta1_ResourceClaimTemplate_To_v1beta2_ResourceClaimTemplate(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1beta1_ResourceClaimTemplateList_To_v1beta2_ResourceClaimTemplateList is an autogenerated conversion function.
func Convert_v1beta1_ResourceClaimTemplateList_To_v1beta2_ResourceClaimTemplateList(in *resourcev1beta1.ResourceClaimTemplateList, out *v1beta2.ResourceClaimTemplateList, s conversion.Scope) error {
	return autoConvert_v1beta1_ResourceClaimTemplateList_To_v1beta2_ResourceClaimTemplateList(in, out, s)
}

func autoConvert_v1beta2_ResourceClaimTemplateSpec_To_v1beta1_ResourceClaimTemplateSpec(in *v1beta2.ResourceClaimTemplateSpec, out *resourcev1beta1.ResourceClaimTemplateSpec, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta2_ResourceClaimSpec_To_v1beta1_ResourceClaimSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_ResourceClaimTemplateSpec_To_v1beta1_ResourceClaimTemplateSpec is an autogenerated conversion function.
func Convert_v1beta2_ResourceClaimTemplateSpec_To_v1beta1_ResourceClaimTemplateSpec(in *v1beta2.ResourceClaimTemplateSpec, out *resourcev1beta1.ResourceClaimTemplateSpec, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceClaimTemplateSpec_To_v1beta1_ResourceClaimTemplateSpec(in, out, s)
}

func autoConvert_v1beta1_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec(in *resourcev1beta1.ResourceClaimTemplateSpec, out *v1beta2.ResourceClaimTemplateSpec, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta1_ResourceClaimSpec_To_v1beta2_ResourceClaimSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta1_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec is an autogenerated conversion function.
func Convert_v1beta1_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec(in *resourcev1beta1.ResourceClaimTemplateSpec, out *v1beta2.ResourceClaimTemplateSpec, s conversion.Scope) error {
	return autoConvert_v1beta1_ResourceClaimTemplateSpec_To_v1beta2_ResourceClaimTemplateSpec(in, out, s)
}

func autoConvert_v1beta2_ResourcePool_To_v1beta1_ResourcePool(in *v1beta2.ResourcePool, out *resourcev1beta1.ResourcePool, s conversion.Scope) error {
	out.Name = in.Name
	out.Generation = in.Generation
	out.ResourceSliceCount = in.ResourceSliceCount
	return nil
}

// Convert_v1beta2_ResourcePool_To_v1beta1_ResourcePool is an autogenerated conversion function.
func Convert_v1beta2_ResourcePool_To_v1beta1_ResourcePool(in *v1beta2.ResourcePool, out *resourcev1beta1.ResourcePool, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourcePool_To_v1beta1_ResourcePool(in, out, s)
}

func autoConvert_v1beta1_ResourcePool_To_v1beta2_ResourcePool(in *resourcev1beta1.ResourcePool, out *v1beta2.ResourcePool, s conversion.Scope) error {
	out.Name = in.Name
	out.Generation = in.Generation
	out.ResourceSliceCount = in.ResourceSliceCount
	return nil
}

// Convert_v1beta1_ResourcePool_To_v1beta2_ResourcePool is an autogenerated conversion function.
func Convert_v1beta1_ResourcePool_To_v1beta2_ResourcePool(in *resourcev1beta1.ResourcePool, out *v1beta2.ResourcePool, s conversion.Scope) error {
	return autoConvert_v1beta1_ResourcePool_To_v1beta2_ResourcePool(in, out, s)
}

func autoConvert_v1beta2_ResourceSlice_To_v1beta1_ResourceSlice(in *v1beta2.ResourceSlice, out *resourcev1beta1.ResourceSlice, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta2_ResourceSliceSpec_To_v1beta1_ResourceSliceSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta2_ResourceSlice_To_v1beta1_ResourceSlice is an autogenerated conversion function.
func Convert_v1beta2_ResourceSlice_To_v1beta1_ResourceSlice(in *v1beta2.ResourceSlice, out *resourcev1beta1.ResourceSlice, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceSlice_To_v1beta1_ResourceSlice(in, out, s)
}

func autoConvert_v1beta1_ResourceSlice_To_v1beta2_ResourceSlice(in *resourcev1beta1.ResourceSlice, out *v1beta2.ResourceSlice, s conversion.Scope) error {
	out.ObjectMeta = in.ObjectMeta
	if err := Convert_v1beta1_ResourceSliceSpec_To_v1beta2_ResourceSliceSpec(&in.Spec, &out.Spec, s); err != nil {
		return err
	}
	return nil
}

// Convert_v1beta1_ResourceSlice_To_v1beta2_ResourceSlice is an autogenerated conversion function.
func Convert_v1beta1_ResourceSlice_To_v1beta2_ResourceSlice(in *resourcev1beta1.ResourceSlice, out *v1beta2.ResourceSlice, s conversion.Scope) error {
	return autoConvert_v1beta1_ResourceSlice_To_v1beta2_ResourceSlice(in, out, s)
}

func autoConvert_v1beta2_ResourceSliceList_To_v1beta1_ResourceSliceList(in *v1beta2.ResourceSliceList, out *resourcev1beta1.ResourceSliceList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]resourcev1beta1.ResourceSlice, len(*in))
		for i := range *in {
			if err := Convert_v1beta2_ResourceSlice_To_v1beta1_ResourceSlice(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1beta2_ResourceSliceList_To_v1beta1_ResourceSliceList is an autogenerated conversion function.
func Convert_v1beta2_ResourceSliceList_To_v1beta1_ResourceSliceList(in *v1beta2.ResourceSliceList, out *resourcev1beta1.ResourceSliceList, s conversion.Scope) error {
	return autoConvert_v1beta2_ResourceSliceList_To_v1beta1_ResourceSliceList(in, out, s)
}

func autoConvert_v1beta1_ResourceSliceList_To_v1beta2_ResourceSliceList(in *resourcev1beta1.ResourceSliceList, out *v1beta2.ResourceSliceList, s conversion.Scope) error {
	out.ListMeta = in.ListMeta
	if in.Items != nil {
		in, out := &in.Items, &out.Items
		*out = make([]v1beta2.ResourceSlice, len(*in))
		for i := range *in {
			if err := Convert_v1beta1_ResourceSlice_To_v1beta2_ResourceSlice(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Items = nil
	}
	return nil
}

// Convert_v1beta1_ResourceSliceList_To_v1beta2_ResourceSliceList is an autogenerated conversion function.
func Convert_v1beta1_ResourceSliceList_To_v1beta2_ResourceSliceList(in *resourcev1beta1.ResourceSliceList, out *v1beta2.ResourceSliceList, s conversion.Scope) error {
	return autoConvert_v1beta1_ResourceSliceList_To_v1beta2_ResourceSliceList(in, out, s)
}

func autoConvert_v1beta2_ResourceSliceSpec_To_v1beta1_ResourceSliceSpec(in *v1beta2.ResourceSliceSpec, out *resourcev1beta1.ResourceSliceSpec, s conversion.Scope) error {
	out.Driver = in.Driver
	if err := Convert_v1beta2_ResourcePool_To_v1beta1_ResourcePool(&in.Pool, &out.Pool, s); err != nil {
		return err
	}
	if err := v1.Convert_Pointer_string_To_string(&in.NodeName, &out.NodeName, s); err != nil {
		return err
	}
	out.NodeSelector = (*corev1.NodeSelector)(unsafe.Pointer(in.NodeSelector))
	if err := v1.Convert_Pointer_bool_To_bool(&in.AllNodes, &out.AllNodes, s); err != nil {
		return err
	}
	if in.Devices != nil {
		in, out := &in.Devices, &out.Devices
		*out = make([]resourcev1beta1.Device, len(*in))
		for i := range *in {
			if err := Convert_v1beta2_Device_To_v1beta1_Device(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Devices = nil
	}
	out.PerDeviceNodeSelection = (*bool)(unsafe.Pointer(in.PerDeviceNodeSelection))
	out.SharedCounters = *(*[]resourcev1beta1.CounterSet)(unsafe.Pointer(&in.SharedCounters))
	return nil
}

func autoConvert_v1beta1_ResourceSliceSpec_To_v1beta2_ResourceSliceSpec(in *resourcev1beta1.ResourceSliceSpec, out *v1beta2.ResourceSliceSpec, s conversion.Scope) error {
	out.Driver = in.Driver
	if err := Convert_v1beta1_ResourcePool_To_v1beta2_ResourcePool(&in.Pool, &out.Pool, s); err != nil {
		return err
	}
	if err := v1.Convert_string_To_Pointer_string(&in.NodeName, &out.NodeName, s); err != nil {
		return err
	}
	out.NodeSelector = (*corev1.NodeSelector)(unsafe.Pointer(in.NodeSelector))
	if err := v1.Convert_bool_To_Pointer_bool(&in.AllNodes, &out.AllNodes, s); err != nil {
		return err
	}
	if in.Devices != nil {
		in, out := &in.Devices, &out.Devices
		*out = make([]v1beta2.Device, len(*in))
		for i := range *in {
			if err := Convert_v1beta1_Device_To_v1beta2_Device(&(*in)[i], &(*out)[i], s); err != nil {
				return err
			}
		}
	} else {
		out.Devices = nil
	}
	out.PerDeviceNodeSelection = (*bool)(unsafe.Pointer(in.PerDeviceNodeSelection))
	out.SharedCounters = *(*[]v1beta2.CounterSet)(unsafe.Pointer(&in.SharedCounters))
	return nil
}
